
cos30 = cos(30);

module hexagon ( a = 10, wall = 2, height = 2, middle = true ) {
    
    if ( middle ) {
        difference () {
            cylinder ( d=(a/cos(30)) + (wall) / cos(30), h=height, $fn=6);
            translate([0,0,-0.5]){
                cylinder ( d=(a/cos(30)) - (wall) / cos(30), h=height+1, $fn=6 );
            }
        }
    }
    else {

        difference () {
            cylinder ( d=a/cos(30), h=height, $fn=6);
            translate([0,0,-0.5]){
                cylinder ( d=(a/cos(30))-(2*wall)/cos(30), h=height+1, $fn=6 );
            }
        }
    }
    
}
/*
translate([0,0,0]) {
hexagon(a=10, wall=1,middle=true); }

translate([0,10,0]) {
hexagon(a=10, wall=1,middle=true); }

translate([10*cos(30),5,0]) {
hexagon(a=10, wall=1,middle=true); }
*/

module hexarea ( radius = 100, hexsize = 10, hexwall= 1, h = 2 ) {

yanz = ceil(radius/hexsize);
xanz = ceil(radius/(hexsize*cos30));

    for ( xx = [0 : xanz] ) {
        for ( yy = [0: yanz ] ) {
            translate([xx*(hexsize*cos30),(yy * hexsize)+(xx % 2) * hexsize/2,0]) {
                hexagon(a=hexsize, wall=hexwall, height=h,middle=true );
            }
            translate([-xx*(hexsize*cos30),(yy * hexsize)+(xx % 2) * hexsize/2,0]) {
                hexagon(a=hexsize, wall=hexwall, height=h,middle=true );
            }
            translate([xx*(hexsize*cos30),-((yy * hexsize)+(xx % 2) * hexsize/2),0]) {
                hexagon(a=hexsize, wall=hexwall, height=h,middle=true );
            }
            translate([-xx*(hexsize*cos30),-((yy * hexsize)+(xx % 2) * hexsize/2),0]) {
                hexagon(a=hexsize, wall=hexwall, height=h,middle=true );
            }
        }
    }
}

hexarea ();